(*^

::[paletteColors = 128; showRuler; automaticGrouping; magnification = 125; currentKernel; 
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e8,  24, "Times"; ;
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e6,  18, "Times"; ;
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, L1, e6,  14, "Times"; ;
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, L1, a20,  18, "Times"; ;
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, L1, a15,  14, "Times"; ;
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, L1, a12,  12, "Times"; ;
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = input, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L1,  12, "Courier"; ;
	fontset = output, output, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; ;
	fontset = message, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = print, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = info, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287, L1,  12, "Courier"; ;
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic, L1,  10, "Times"; ;
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = Left Header, nohscroll, cellOutline,  12;
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, L1,  12;
	fontset = Left Footer, cellOutline, blackBox,  12;
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12, "Courier"; ;
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;]
:[font = title; inactive; preserveAspect; startGroup; ]
The Cantor Function
:[font = subsubtitle; inactive; preserveAspect; ]
Steven R. Dunbar
Department of Mathematics and Statistics
University of Nebraska-Lincoln
:[font = subsubtitle; inactive; preserveAspect; ]
David Fowler
Department of Curriculum and Instruction
University of Nebraska-Lincoln
:[font = smalltext; inactive; preserveAspect; right; ]
 Copyright  Steven R. Dunbar, David Fowler, 1992, All rights reserved.  T
;[s]
2:0,0;1,1;74,-1;
2:1,0,0,Symbol,0,10,0,0,0;1,9,7,Times,0,10,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Before Starting
:[font = input; preserveAspect; ]
SetDirectory["mma"]
:[font = input; preserveAspect; ]
Get["CantorSet.ma"]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup; ]
Terminology:
:[font = text; inactive; preserveAspect; endGroup; endGroup; ]
You will need to have an understanding of the following terms to use this Notebook and solve the problems:uniform convergence, monotone function, jump discontinuity, left- and right- derivatives, Riemann-Stieltjes integral, moments.  Some problems may require the notion of measure and  Lebesgue integral.
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Cantor Functions 
:[font = text; inactive; preserveAspect; ]
In this Notebook we construct a function y(x) which is closely related to the Cantor set.  In fact, this function is increasing with its increase taking place only on the ``thinly scattered'' points of the Cantor set!.  Because it is an increasing function with value 0 at the left end of the defining interval, and value 1 at the right end of the defining interval, it can be considered as a cumulative distribution function of the sort considered in probability and statistics.  As such, it serves as an important example of a ``badly behaved function'' in a certain sense  discussed in measure theory and integration.  It is also of interest to consider the mean, the variance, and higher moments of this distribution as a concrete example of Riemann-Stieltjes integration.
;[s]
3:0,0;41,1;42,2;776,-1;
3:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
Let Ek,j, (j= 1,....2k-1) denote the open deleted intervals complementary to Ik in the sequential construction of C[[a,b], r1,r2], numbered from left to right in order.  Let yk(x) be the unique continuous function on [a,b] such that yk(a) = 0, yk(b) = 1, yk(x) is linear on each interval of Ik and Ek,j  and 
	yk(x) = j 2-k	 if x  Ek,j  ,	j=1,...2k-1. 
;[s]
31:0,0;5,1;8,2;21,3;22,4;78,5;79,6;174,7;175,8;176,9;233,10;234,11;235,12;244,13;245,14;246,15;255,16;256,17;257,18;292,19;294,20;299,21;303,22;310,23;311,24;312,25;321,26;331,27;332,28;333,29;338,30;353,-1;
31:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,0,0,Symbol,32,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
Then  yk is clearly nondecreasing, yk+1 = yk on  Ek,j,  and 
	 yk+1(x) - yk(x) < 2-k.
Hence the sequence converges uniformly on [a,b].  Its limit y(x) is continuous, y(a) = 0, y(b)=1,  and y(x) is constant on any interval complementary to any set Ik. 
;[s]
35:0,0;6,1;7,2;8,3;35,4;36,5;39,6;42,7;43,8;44,9;50,10;53,11;62,12;65,13;68,14;74,15;75,16;76,17;79,18;80,19;84,20;86,21;148,22;149,23;168,24;169,25;178,26;179,27;181,28;186,29;191,30;192,31;250,32;251,33;252,34;253,-1;
35:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
Here is an illustration of the uniform convergence of these piecewise linear approximations.
:[font = input; preserveAspect; ]
Show[ Graphics[{cantorFunction[1],
                cantorFunction[2],
                cantorFunction[3]}
              ],
       Axes -> True,
       AspectRatio -> Automatic]
:[font = text; inactive; preserveAspect; ]
And here is an illustration of ( a very close approximation, to within screen resolution of ) the  classical Cantor function.
:[font = input; preserveAspect; ]
Show[ Graphics[ cantorFunction[7]],
	Axes -> True,
	AspectRatio -> Automatic]
:[font = text; inactive; preserveAspect; ]
Here is an illustration of a generalized Cantor function, based on the generalized Cantor set with preservation ratios r1=1/10, and r2=1/2.5, that is, removing a portion 1 -( 1/10+1/2.5) at each stage.
;[s]
5:0,0;120,1;121,2;133,3;134,4;202,-1;
5:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; endGroup; ]
Show[ Graphics[ psi[{0,2}, 1/10, 1/2.5, 7]],
	Axes -> True,
	AspectRatio -> Automatic]
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Symmetries and Functional Relations
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup; ]
Symmetries of the Classical Cantor Function
:[font = text; inactive; preserveAspect; ]
It should be obvious from the graph that the classical Cantor function satisfies some symmetry relations.  These are 
	y(0) = 0
 	y(x/3) = y(x)/2
 	y(1-x) = 1 - y(x).
The exercises demonstrate that these symmetries completely characterize the classical Cantor function. 
;[s]
11:0,0;118,1;120,2;130,3;131,4;139,5;140,6;148,7;149,8;161,9;162,10;270,-1;
11:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
Using the recursive function definition possible with Mathematica  we can use these symmetries to draw the graph of the classical Cantor function.  First define the function using the symmetries, slightly rearranged:
;[s]
3:0,0;54,1;65,2;216,-1;
3:1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
f[0] := 0
f[x_] := f[3 x] /2	 /;   x <= 1/3
f[x_] := 1 - f[1-x] /; 2/3 <= x
:[font = text; inactive; preserveAspect; ]
Define an operation to draw the constant portions of the graph on the complementary intervals: 
:[font = input; preserveAspect; ]
connect[{a_, b_}] := Module[{y=f[a]},Line[{{a,y},{b,y}}]]
:[font = text; inactive; preserveAspect; ]
Then draw an approximation to the Cantor function, together with some boxes to make the symmetries apparent.
:[font = input; preserveAspect; ]
Show[ Graphics[Join[
 Map[connect, complementaryIntervals[4]],
 { GrayLevel[0.5], Line[{{1/3,0},{1/3,1/2}}],
   Line[{{0,1/2},{1/3,1/2}}],
   Line[{{2/3,1/2},{1,1/2}}],
   Line[{{2/3,1/2},{2/3,1}}]}],
	AxesOrigin -> {0,0},
	Axes -> True,
	AspectRatio -> Automatic
	]]
:[font = text; inactive; preserveAspect; ]
Finally draw (a very good  approximation of, to within about screen resolution) the Cantor function using the recursivesymmetry relations to obtain the function values.   
:[font = input; preserveAspect; endGroup; ]
Show[ Graphics[ Map[connect, complementaryIntervals[7]],
	Axes -> True,
	AspectRatio -> Automatic
	]]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup; ]
The Cantor Set from a Chaos Game
:[font = text; inactive; preserveAspect; ]
The symmetries illustrated again  below shows that portions of the graph of the Cantor function are similar to sub-portions.  Alternatively, the graph of the Cantor function may be expressed as the union of affine contractions.  According to Barnsley's Collage Theorem, this means we may generate the graph of the Cantor function from an appropriate Chaos game.  
:[font = input; preserveAspect; ]
Show[ Graphics[Join[
 Map[connect, complementaryIntervals[4]],
 { GrayLevel[0.5], Line[{{1/3,0},{1/3,1/2}}],
   Line[{{0,1/2},{1/3,1/2}}],
   Line[{{2/3,1/2},{1,1/2}}],
   Line[{{2/3,1/2},{2/3,1}}]}],
	AxesOrigin -> {0,0},
	Axes -> True,
	AspectRatio -> Automatic
	]]
:[font = input; preserveAspect; ]
f1[{x1_, x2_}] := {x1/3, x2/2};
f2[{x1_, x2_}] := {x1/3 + 1/3, 1/2};
f3[{x1_, x2_}] := {x1/3 + 2/3, x2/2 + 1/2};
f[{x1_,x2_}] := 
	{f1,f2,f3}[[Random[Integer,{1,3}]]][{x1,x2}];

:[font = input; preserveAspect; ]
ChaosGame[start_, n_] := 
	Show[ Graphics[
	{PointSize[0.001], Map[Point, NestList[f, start, n]]}],
		PlotRange -> {{0,1},{0,1}}, Axes -> Automatic,
		AspectRatio -> Automatic];
:[font = input; preserveAspect; endGroup; ]
ChaosGame[ {.1, .8}, 5000]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup; ]
Generalized Symmetries and Cantor Functions ``under pressure''
:[font = text; inactive; preserveAspect; ]
An interesting generalization is to introduce the parameter r into the symmetry relations as
	y(0 ; r) = 0
	y(x/3; r) = y(x; r)/(p+1)
	yr(1-x; r) = 1 - r y(x; r) 
;[s]
13:0,0;94,1;95,2;108,3;109,4;120,5;121,6;135,7;136,8;137,9;154,10;156,11;160,12;163,-1;
13:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;
:[font = input; preserveAspect; ]
f[0] := 0
f[x_] := f[3 x] /(r + 1)	/;   x <= 1/3
f[x_] := 1 - r f[1-x] /; 2/3 <= x
:[font = input; preserveAspect; ]
pressedCantorFunction[parameter_] := (r = parameter;
	Show[Graphics[{Thickness[.001],
	Map[connect, removedIntervals[6]]}],
	PlotRange -> {{0,1},{0,1}},
	Axes -> True,
	AspectRatio -> Automatic]);
Attributes[pressedCantorFunction] = {Listable}
:[font = input; preserveAspect; endGroup; ]
pressedCantorFunction[{.01,.1,.3,.5,1,4,10,100}]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup; ]
Symmetries of the Generalized Cantor Function 
:[font = text; inactive; preserveAspect; endGroup; endGroup; ]
The generalized Cantor function based on the Cantor set with ratios r1 and r2 (on the interval [0,1] for simplicity of notation) also satisfies some functional relationships:
	y(r1 x; r1, r2)  = y(x; r1, r2)/2
	y(1 - r2 x; r1, r2) = 1 - y(x,  r1,r2)/2
	y( (1-x)r1 + x(1-r2); r1,r2) = 1/2
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Derivatives of the Cantor Function
:[font = text; inactive; preserveAspect; ]
It is easy to see from the graph of the Cantor Function that the derivative of the Cantor function is zero on the interior of any complementary interval.  This follows rigorously from the definition as a limit of piecewise linear functions.  At the endpoints of a complementary interval the derivative is more interesting.  For instance, at a right-endpoint of a  complementary interval, the left-derivative is zero.  Consider the following graph of secant lines approximating the derivative to the Cantor function at x = 2/3.  The secant lines are taken through the point on the graph of the Cantor function at an endpoint of another complementary interval to the right.
:[font = input; preserveAspect; ]
complementaryIntervals[5]
:[font = text; inactive; preserveAspect; ]
Define some functions to indicate the x-coordinate where the secant line will intersect the lines y = 1, and y = 0 ( at the top and bottom of the graphing region)
:[font = input; preserveAspect; ]
xtop[x_] := (1/2)*( 2/3 - x)/(1/2 - f[x]) +2/3
:[font = input; preserveAspect; ]
xbot[x_] := (-1/2)*( 2/3 - x)/(1/2 - f[x]) +2/3
:[font = text; inactive; preserveAspect; ]
Draw the Cantor function and several of the secant lines through endpoints chosen more or less arbitrarily from the list above.
:[font = input; preserveAspect; ]
Show[ Graphics[ {cantorFunction[6], 
	Line[ {{xbot[20/27], 0}, {xtop[20/27], 1}}],
	Line[ {{xbot[56/81], 0}, {xtop[56/81], 1}}],
	Line[ {{xbot[163/243], 0}, {xtop[163/243], 1}}]},
	Axes -> True, AspectRatio -> Automatic]]

:[font = input; preserveAspect; endGroup; ]
Show[ GraphicsArray[
 		{
			{cantorFunction[4],
				Line[{{xbot[20/27],0},{xtop[20/27],1}}]},
			{cantorFunction[4],
				Line[{{xbot[56/81],0},{xtop[56/81],1}}]},
			{cantorFunction[4],
				Line[{{xbot[163/243],0},{xtop[163/243],1}}]},
		}]]

:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Riemann-Stieltjes Integrals
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup; ]
Riemann Integral
:[font = text; inactive; preserveAspect; ]
Since the Cantor function is continuous, it is integrable.  Using the functional relations, it is possible to find the value of the integral. 
	01/3 y(x) dx = 01 y(u/3) du/3 = (1/6) 01  y(x) dx
Then using the partitioned figure below:
	01  y(x) dx  = (2/6) 01  y(x) dx + 2/6, so 01  y(x) dx  = 1/2.
;[s]
31:0,0;144,1;145,2;146,3;150,4;151,5;160,6;161,7;162,8;164,9;165,10;184,11;185,12;186,13;189,14;190,15;239,16;240,17;241,18;244,19;245,20;261,21;262,22;263,23;266,24;267,25;284,26;285,27;286,28;289,29;290,30;291,-1;
31:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,18,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,18,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,18,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,18,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,18,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,18,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;
:[font = input; preserveAspect; endGroup; ]
Show[ Graphics[Join[
 Map[connect, complementaryIntervals[7]],
 {GrayLevel[0.6], Line[{{1/3,0},{1/3,1/2}}],
   Line[{{2/3,0},{2/3,1/2}}],
   Line[{{2/3,1/2},{1,1/2}}],
   Line[{{1,0},{1,1}}]}],
	AxesOrigin -> {0,0},
	Axes -> True,
	AspectRatio -> Automatic
	]]
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup; ]
First Moment as a Riemann-Stieltjes Integral
:[font = text; inactive; preserveAspect; ]
Since the Cantor function is increasing, it is a natural for use with Riemann-Stieltjes integration.  Alternatively, we can view the Cantor function as a cumulative distribution function for some probability and then calculate its mean:  01 x dy(x).  It is easiest to do this by calculating Riemann-Stieltjes sums for 01 x dyk(x) and passing to the limit.
;[s]
14:0,0;238,1;239,2;240,3;241,4;245,5;246,6;319,7;320,8;321,9;322,10;326,11;327,12;328,13;357,-1;
14:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,20,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,0,0,Symbol,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,20,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,0,0,Symbol,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
intervals[3]
:[font = input; preserveAspect; ]
Midpoint[l_List] := (l[[1]] + l[[2]])/2
:[font = input; preserveAspect; ]
weight[l_List] := f[ l[[2]] ] - f[ l[[1]] ]  
:[font = input; preserveAspect; ]
RSsummand[l_List] := Midpoint[l] * weight[l]
:[font = input; preserveAspect; ]
 intervals[5];
:[font = input; preserveAspect; ]
Map[ RSsummand, %]
:[font = input; preserveAspect; endGroup; endGroup; ]
Apply[ Plus, %]
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Basic Exercises
:[font = text; inactive; preserveAspect; ]
1. Give a clear and complete  proof that the sequence of functions yk(x) converges uniformly on {a,b}.
;[s]
6:0,0;67,1;68,2;69,3;96,4;97,5;102,-1;
6:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
2. Suppose that f(x) is continous on [0,1], f(x) is differentiable almost everywhere, and f'(x) is integrable ( f'(x)  L1[0,1]).  Is it necessarily true that 
	f(1) - f(0) = 01 f'(x) dx?
;[s]
9:0,0;118,1;120,2;121,3;122,4;175,5;176,6;177,7;178,8;188,-1;
9:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
3. What are the functional relationships for the generalized Cantor function based on the generalized Cantor set on [a,b] with ratios r1, r2?
:[font = text; inactive; preserveAspect; endGroup; ]
4. What is the area under the Cantor function ``under pressure'' with pressure parameter r?
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Try for Yourself
:[font = text; inactive; preserveAspect; ]
1. Show that the Cantor function is strictly increasing on the Cantor set
:[font = text; inactive; preserveAspect; ]
2. Let f(x) be monotone increasing function satisfying f(0) = 0, f(x/3) = f(x)/2, and f(1-x) = 1 - f(x).
(a)  Show that f(x) and the classical Cantor function y(x) agree on a dense subset of [0,1].
(b)  Show that therefore f(x) must be continuous.  (Recall that the only discontinuities of a monotone function are jump discontinuities).
(c) Conclude that f(x) = y(x).
;[s]
5:0,0;159,1;160,2;362,3;364,4;367,-1;
5:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
3. Show that at the right endpoint of a complementary interval, the Cantor function has  a right-derivative which is  infinite:  f+'(x) = .
;[s]
5:0,0;130,1;131,2;132,3;138,4;140,-1;
5:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;
:[font = text; inactive; preserveAspect; endGroup; ]
4. Find and prove a  formula for the mean value of the generalized Cantor function with ratios r1 and r2.
;[s]
4:0,0;96,1;97,2;103,3;105,-1;
4:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Have Fun with Mathematica
:[font = text; inactive; preserveAspect; endGroup; ]
1. Devise some Mathematica code or procedures to animate the  secantlines through points on the graph of the Cantor function approaching the right-derivative at the endpoint of a complementary interval. 
;[s]
3:0,0;15,1;26,2;203,-1;
3:1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
References
:[font = text; inactive; preserveAspect; ]
Information on the traditional Cantor function can be found anywhere there is information on the traditional Cantor set.  Two readily available sources are
Principles of  Mathematical  Analysis,3rd edition, Walter Rudin, McGraw-Hill, New York, 1976
and
A Primer of Real Functions, Carus Mathematical Monographs 13, R. P. Boas, Mathematical Association of America, Washington, 1981.
;[s]
5:0,0;156,1;193,2;253,3;281,4;382,-1;
5:1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
The discussion of the functional relations and the symmetries of the traditional Cantor function comes from ``A Characterizationof the Cantor Function'', D. R. Chalice, Amer. Math. Monthly, Volume 98, Number 3, March 1991, pp. 255-259.   This article also contains the idea for the ``stressed'' Cantor function.
:[font = text; inactive; preserveAspect; ]
The definition of the Cantor function used here comes from  ``An Interesting Cantor Set'', W. A. Coppel, Amer. Math. Monthly, Volume 90, number 7, August-September 1983, pp.456-461.  The discussion of the moments of the Cantor function comes from the same source.
:[font = text; inactive; preserveAspect; endGroup; endGroup; ]
Some of the  ideas for the Mathematica code, and the animation of the generalized Cantor sets with a parameter are adapted from Mathematica in Action, Stan Wagon, W. H. Freeman, New York, 1991
;[s]
5:0,0;128,1;139,2;140,3;151,4;192,-1;
5:1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
^*)