(*^

::[paletteColors = 128; showRuler; automaticGrouping; magnification = 125; currentKernel; 
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e8,  24, "Times"; ;
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e6,  18, "Times"; ;
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, L1, e6,  14, "Times"; ;
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, L1, a20,  18, "Times"; ;
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, L1, a15,  14, "Times"; ;
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, L1, a12,  12, "Times"; ;
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = input, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L1,  12, "Courier"; ;
	fontset = output, output, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; ;
	fontset = message, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = print, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = info, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287, L1,  12, "Courier"; ;
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic, L1,  10, "Times"; ;
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = Left Header, nohscroll, cellOutline,  12;
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, L1,  12;
	fontset = Left Footer, cellOutline, blackBox,  12;
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12, "Courier"; ;
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;]
:[font = title; inactive; preserveAspect; startGroup; ]
Measure and Dimension of the Cantor Set
:[font = subsubtitle; inactive; preserveAspect; ]
Steven R. Dunbar
Department of Mathematics and Statistics
University of Nebraska-Lincoln
:[font = subsubtitle; inactive; preserveAspect; ]
David Fowler
Department of Curriculum and Instruction
University of Nebraska-Lincoln
:[font = smalltext; inactive; preserveAspect; right; ]
 Copyright  Steven R. Dunbar, David Fowler, 1992, All rights reserved.  T
;[s]
2:0,0;1,1;74,-1;
2:1,0,0,Symbol,0,10,0,0,0;1,9,7,Times,0,10,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Before Starting
:[font = input; preserveAspect; endGroup; ]
Get["CantorSet.ma"]
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Lebesgue Measure
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup; ]
Measure Zero
:[font = text; inactive; preserveAspect; ]
A subset  E of the real line R which can be covered by a countable collection of open intervals whose total length is arbitrarily small is said to be a set of measure zero.  The classical excluded-middle-thirds Cantor set C is a set of measure zero.   
:[font = text; inactive; preserveAspect; ]
Here are three stages in determining the measure of the classical Cantor set.  At each stage we use open sets containing the intervals remaining after the middle-third removal process.
:[font = input; preserveAspect; ]
lines[l_List] :=
    Map[Line[{{#[[1]],0}, {#[[2]], 0}}] &,l];
:[font = input; preserveAspect; ]
superSets[f_,delta_]:=Map[{#[[1]]-delta,#[[2]]+delta} &, f]
:[font = input; preserveAspect; ]
rarc[s_]:=Circle[{(s[[1]]+s[[2]])/2,0},
					  (s[[2]]-s[[1]])/2, {-Pi/6,Pi/6}];
:[font = input; preserveAspect; ]
larc[s_]:=Circle[{(s[[1]]+s[[2]])/2,0},
					  (s[[2]]-s[[1]])/2, {5Pi/6,7Pi/6}];
:[font = input; preserveAspect; ]
Table[Show
		[Graphics
			[{Thickness[0.01], lines[intervals[k]],{Thickness[.001],
			Line[{{-0.1,0},{1.1,0}}],
			Map[larc,superSets[intervals[k], 0.1/2^k]],
			Map[rarc,superSets[intervals[k], 0.1/2^k]]
			}}],
			PlotRange->{{-0.1,1.1},{-1,1}},
			AspectRatio->.5],{k,3}];
:[font = text; inactive; preserveAspect; ]
We can show the Cantor has measure zero by using the sets resulting from the excluded-middle-thirds process.  We directly compute the total length of the intervals remaining after each of the stages of the middle-third removal process.  The reader should verify that this is permissible, since we are covering the classical  Cantor set with closed intervals instead of open intervals as in the definition. 
:[font = input; preserveAspect; ]
Table[  Apply[Plus, Minus[Apply[Subtract, intervals[i], {1}]]],
 {i, 10}]
:[font = input; preserveAspect; endGroup; ]
N[%]
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup; ]
Lebesgue Measure
:[font = text; inactive; preserveAspect; ]
In R, the class of Borel sets is the smallest collection of subsets of R such that
	(1) every open set and every closed set is a Borel set.
	(2) the union of every finite or countable collection of Borel sets is a Borel set, 	and the intersection of any finite or countable collection of Borel sets is a Borel set.
:[font = text; inactive; preserveAspect; ]
We call  m a measure on R if m assigns a non-negative number m(A), possibly , called the measure  of  A to each set A  in some class of subsets of R (for instance the Borel sets) such that:
	(1)	 m() = 0
	(2)	m(A)  m(B), for A  B
	(3)	If A1, A2, ... is a countable sequence of sets then
				m(i=1 Ai)  i=1 m(Ai)
				
		with equality if the Ai are disjoint Borel  sets.
;[s]
37:0,0;9,1;10,2;29,3;30,4;61,5;62,6;76,7;77,8;216,9;217,10;229,11;232,12;243,13;244,14;247,15;248,16;295,17;296,18;297,19;298,20;301,21;302,22;304,23;305,24;307,25;308,26;309,27;310,28;313,29;314,30;315,31;316,32;318,33;319,34;350,35;351,36;378,-1;
37:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,0,0,Symbol,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,0,0,Symbol,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
For open and closed intervals, we take the Lebesgue measure to be  m((a,b)) = b-a, and m([a,b]) = b-a.  If A = [ai,bi] is a finite or countable union of intervals, then m(A) =(bi-ai).  For an arbitrary Borel  set A on the real line, define
	m(A) = inf (  (bi-ai) : A   [ai,bi])
that is, we look at all coverings of A by countable unions of intervals and take the smallest total interval length possible.
;[s]
35:0,0;67,1;68,2;87,3;88,4;111,5;112,6;114,7;115,8;117,9;118,10;170,11;171,12;176,13;177,14;179,15;180,16;182,17;183,18;243,19;244,20;256,21;257,22;260,23;261,24;263,25;264,26;271,27;272,28;273,29;274,30;276,31;277,32;279,33;280,34;409,-1;
35:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
Table[  Apply[Plus, 
	Minus[Apply[Subtract, cantorSet[{0,2}, 1/2.5, 1/2.5, i], {1}]]],
	{i,9}]
:[font = input; preserveAspect; ]
 Apply[Plus, 
	Minus[Apply[Subtract, cantorSet[{0,2}, 1/2.5, 1/2.5, 12], {1}]]]
:[font = text; inactive; preserveAspect; endGroup; endGroup; ]
From this it would appear that the generalized Cantor set of ratio 1/2.5, 1/2.5  on [0,2] has Lebesgue measure zero.   Indeed this is the case, since  at each stage of the construction there are 2n intervals of length 2 (2/5)n containing the Cantor set under consideration.  Thus the measure is zero.
;[s]
5:0,0;196,1;197,2;225,3;227,4;350,-1;
5:1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Box-Counting Dimension
:[font = text; inactive; preserveAspect; ]
Consider a subet E of the real line R, and consider  the d-mesh on R given by the collection of intervals [n d, (n+1) d] where n is an integer.  Let Nd(F) be the number of d-mesh intervals which intersect the set F, Nd(F) = card{n : [n d, (n+1) d]  F  }.
;[s]
21:0,0;57,1;58,2;109,3;110,4;118,5;119,6;150,7;151,8;172,9;173,10;217,11;218,12;236,13;237,14;241,15;249,16;252,17;253,18;254,19;255,20;257,-1;
21:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
Show[ Graphics[ {Thickness[.004], lines[intervals[5]]}],
Frame -> True,
FrameTicks -> {Automatic, None},
GridLines -> {Table[i/40, {i,0,40}], None},
PlotRange -> {{0,1}, {-0.05, 0.05}},
AspectRatio -> 0.1,
PlotRegion -> {{0,0.8},{0,0.8}} ]
(* Plot parameters obtained by experimentation.  
Parameters added to give proper effect. *)
:[font = text; inactive; preserveAspect; ]
Then define the box-counting dimension of F as
                                              ( log(Nd(F))
          dimB(F) =         lim    -----------------
                                   d -> 0       -log d
  provided  the limit exists.
;[s]
9:0,0;100,1;101,2;119,3;120,4;194,5;195,6;212,7;213,8;244,-1;
9:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
To determine the  box-counting dimension of the Cantor set with this definition requires a double limiting  process, one using the excluded-middle-thirds process to generate approximations to the Cantor set, and the other using boxes of a given size.  Nevertheless, without proving the required theorem validating the double-limit process, we can make experimental approximations to the box-counting dimension of the Cantor set.
:[font = text; inactive; preserveAspect; ]
We will take the list of endpoints generated by the middle-thirds process at stage n as an approximation to the Cantor set.  Then multiply each point of this set by 1/d and take the Floor  of the result.  This gives the box-index of each point   Then taking the Union gives a list of the distinct box-indices which contain an endpoint of the Cantor set.  The cardinality is then given by the Length of the list. 
;[s]
3:0,0;167,1;168,2;412,-1;
3:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
boxCount[l_List, delta_] :=
	Length[ Union[ Floor[(1/delta)*l]]]
:[font = input; preserveAspect; ]
boxCount[Flatten[intervals[5]], 1/40]
:[font = input; preserveAspect; ]
approxDimension[ l_List, delta_] := 
	N[ Log[ boxCount[l,delta]]/(-Log[delta])]
:[font = input; preserveAspect; ]
approxDimension[ Flatten[intervals[10]], 1/2^10]
:[font = text; inactive; preserveAspect; ]
Alternative definitions of the box-counting dimension exist, for instance one can let Nd(F) be the smallest number of balls of radius d that cover F, or the largest number of disjoint balls of radius d that cover F.  Theorems are needed to establish that these alternate definitions are equivalent.  Taking the first alternate definition as the smallest number of balls of radius d needed to cover F, taking F as the classical Cantor set, taking  d = 1/3n, then clearly it requires at most 2n such balls to cover.  Then the dimension will be (less than)
	lim n->0 (log(2n)/(-log(1/3n))) = log(2)/log(3) = 0.63093...
;[s]
21:0,0;87,1;88,2;134,3;135,4;200,5;201,6;380,7;381,8;447,9;448,10;454,11;457,12;491,13;493,14;559,15;564,16;570,17;571,18;582,19;583,20;615,-1;
21:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; endGroup; ]
Later we will get  theorem allowing us to calculate the dimension without approximating the limiting process in certain cases.
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Hausdorff Dimension
:[font = text; inactive; preserveAspect; ]
Let F be a subset of R, and let s be a non-negative number.  For any d > 0, define	Hds(F) = inf{  |Ui|s : { Ui} is a d-cover of F}.   Here |U| = sup{ | x-y | : x,y  U} is the diameter of U.  A countable collection {Ui} is said to be a d-cover of F if  F   Ui. and each of the Ui has diameter less than d.  Define the Hausdorff s-measure as 
	Hs(F) = lim d->0 Hds(F)
Usually this limit is either 0 or .  Finally define the Hausdorff dimension of F as
	dimH(F) = inf{ s : Hs(F) = 0} = sup{s : Hs(F) = }.  Note that if s = dimH(F), then Hs(F) may be 0,  or some finite value.  
	 
:[font = text; inactive; preserveAspect; ]
For the Cantor set, let d > 0 given.  For n so large that 1/3n < d, the intervals remaining after n stages of the middle third removal process are a  d-cover of the Cantor set C.  Then it is easy to graph Hds(C) as a function of s for several sizes of d.
;[s]
16:0,0;24,1;30,2;61,3;63,4;65,5;68,6;71,7;72,8;150,9;151,10;206,11;207,12;208,13;252,14;253,15;255,-1;
16:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
Plot[ { Apply[Plus, Minus[Apply[Subtract, intervals[2], {1}]]^s],
        Apply[Plus, Minus[Apply[Subtract, intervals[5], {1}]]^s],
        Apply[Plus, Minus[Apply[Subtract, intervals[7], {1}]]^s]},
 {s,0,1}, PlotRange->{{0,1}, {0,10}}]
:[font = text; inactive; preserveAspect; endGroup; ]
For d < 0.63, it appears that Hds(C) is increasing and getting very large as d -> 0.  For d > 0.63 it appears that Hds(C) is going to zero as d -> 0.  From this, we should conjecture (and prove!) that dimH(C)  0.63. 
;[s]
18:0,0;4,1;5,2;31,3;32,4;33,5;77,6;78,7;90,8;91,9;116,10;117,11;118,12;142,13;143,14;204,15;205,16;209,17;217,-1;
18:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Similarity Dimension
:[font = text; inactive; preserveAspect; ]
A set of mappings S1, S2,Sm: Rn  -> Rn is said to be a set of contractive similarities if 
	| Si(x) - Si(y)| = ci |x - y|, for all x,y  Rn and for all i = 1m. 
The ci are called the ratios of the similarities.   The following theorem is fundamental:
;[s]
25:0,0;19,1;20,2;23,3;24,4;27,5;28,6;31,7;32,8;38,9;39,10;96,11;97,12;104,13;105,14;113,15;114,16;136,17;137,18;139,19;140,20;168,21;169,22;185,23;191,24;252,-1;
25:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
Theorem:  Let mappings S1, S2,Sm: Rn  -> Rn be a set of contractive similarities on
D  Rn.  Then there exists a unique non-empty compact subset F that is invariant for the Si, i.e.  which satisfies
		F =  i=1m Si(F).
Moreover, if we define a transformation S on the set of non-empty compact sets by 
			S(E) =  i=1m Si(E).
and write Sk for the kth iterate of S given by S0(E) = E, Sk(E) = S(Sk-1(E)) for k  1, then
		F = k=1 Sk(E)
for any set E in the set of non-empty compact sets such that Si(E)  E for each i.
The Cantor set is an application of this idea which we have already seen in the context of the deterministic  iteration of the iterated-function-system idea:
 
;[s]
45:0,0;24,1;25,2;28,3;29,4;32,5;33,6;36,7;37,8;43,9;44,10;86,11;88,12;175,13;176,14;207,15;208,16;211,17;212,18;214,19;215,20;314,21;315,22;318,23;319,24;321,25;322,26;338,27;339,28;375,29;376,30;386,31;387,32;396,33;399,34;426,35;427,36;430,37;431,38;433,imes,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,T1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,0,0,Symbol,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
i0 = {{0,1}}  (* A list of intervals, here 1 interval *)
:[font = input; preserveAspect; ]
affinemaps = {{0,1/3},{2/3, 1/3}}
(* Affine maps 0 + (1/3)x and 2/3 + (1/3)x  *)
:[font = input; preserveAspect; ]
mapUnion[i0,affinemaps]
:[font = input; preserveAspect; ]
mapUnion[%, affinemaps]
:[font = input; preserveAspect; ]
NestList[mapUnion[#, affinemaps] &, i0, 4] //MatrixForm
:[font = text; inactive; preserveAspect; ]
Here is another illustration of this theorem, this time in R2.
;[s]
3:0,0;60,1;61,2;63,-1;
3:1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
affinemaps = {   { {0,0}, {{1/2,0},{0,1/2}}  },
				 { {1/2,0}, {{1/2,0},{0,1/2}} },
				 { {1/4,Sqrt[3]/4}, {{1/2,0},{0,1/2}} }
			 }
:[font = input; preserveAspect; ]
e = { {{0,0},{1,0},{1,1},{0,1}} }  (* a list of polygons! *)
:[font = input; preserveAspect; ]
	imagegon[pgon_] := Table[ 
		Map[
			affinemaps[[i,1]] + affinemaps[[i,2]] . # &, 
			pgon],
		{i,Length[affinemaps]}]
:[font = input; preserveAspect; ]
itergon[pgon_] := Partition[Flatten[imagegon[Flatten[pgon,1]],1],4]
:[font = input; preserveAspect; ]
graphgon[pgon_,gray_] := {GrayLevel[gray], Map[Polygon, itergon[pgon]]} 
:[font = input; preserveAspect; ]
Show[ Graphics[ Table[ graphgon[e2,0.5]]]
:[font = input; preserveAspect; ]
seq = NestList[itergon,e,6];
:[font = input; preserveAspect; ]
Do[seq[[i]] = 
	{GrayLevel[1.0 - i*(0.9)/Length[seq]],Map[Polygon, seq[[i]]]},
	{i,1,Length[seq]} ]

:[font = input; preserveAspect; ]
Length[seq]
:[font = input; preserveAspect; ]
Show[Graphics[seq], AspectRatio -> Automatic]
:[font = text; inactive; preserveAspect; ]
The set of mappings S1,Sm satisfy the open set condtion if there is a non-empty bounded open set V such that
	V   i=1m  Si(V).
Here is an illustration showing that the previous example in R2 satisfies the open set condition.
;[s]
18:0,0;21,1;22,2;25,3;26,4;39,5;56,6;113,7;114,8;116,9;117,10;120,11;121,12;123,13;124,14;125,15;192,16;193,17;228,-1;
18:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,25,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = input; preserveAspect; ]
affinemaps = {   { {0,0}, {{1/2,0},{0,1/2}}  },
				 { {1/2,0}, {{1/2,0},{0,1/2}} },
				 { {1/4,Sqrt[3]/4}, {{1/2,0},{0,1/2}} }
			 }
:[font = input; preserveAspect; ]
pgon = { {0,0},{1,0},{1,1},{0,1}}
:[font = input; preserveAspect; ]

	imagegons = Table[ 
		Map[
			affinemaps[[i,1]] + affinemaps[[i,2]] . # &, 
			pgon],
		{i,Length[affinemaps]}]
:[font = input; preserveAspect; ]
Show[ Graphics[ { GrayLevel[0.7], Polygon[ pgon], 
	GrayLevel[0.3], Map[Polygon, imagegons] }], Axes -> True,
	 AspectRatio -> 1, PlotRange -> All ]
:[font = text; inactive; preserveAspect; ]
Similarity Dimension Theorem:  Suppose that the open set condition holds for the similarities Si on  Rn with ratios ci for 1  i  m.  If F is the invariant set satisfying 
	F =  i=1m Si(F)
then dimH(F) = dimB(F) = s, where s is given by 
	i=1m  cis  =  1.
;[s]
32:0,0;95,1;96,2;102,3;103,4;117,5;118,6;125,7;126,8;128,9;130,10;179,11;180,12;183,13;184,14;185,15;186,16;187,17;199,18;200,19;209,20;210,21;241,22;242,23;243,24;245,25;248,26;249,27;250,28;253,29;254,30;255,31;258,-1;
32:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,25,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,19,0,0,0;1,13,10,Times,64,15,0,0,0;1,0,0,Symbol,64,15,0,0,0;1,13,10,Times,32,15,0,0,0;1,13,10,Times,0,15,0,0,0;1,13,10,Times,64,15,0,0,0;1,13,10,Times,32,15,0,0,0;1,13,10,Times,64,15,0,0,0;1,13,10,Times,32,15,0,0,0;1,13,10,Times,64,15,0,0,0;
:[font = text; inactive; preserveAspect; ]
Using this theorem and the illustration above demonstrating that the affine mappings defing the Cantor set satisfy the open set condition, we can find the Hausdorff dimension of the Cantor set.
:[font = input; preserveAspect; ]
Solve[ (1/3)^s + (1/3)^s ==1, s]
:[font = input; preserveAspect; endGroup; ]
N[%]
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Basic Exercises
:[font = text; inactive; preserveAspect; ]
1. a.) Suppose that instead of calculating the Lebesgue measure of the classical Cantor set with the closed intervals of the ith stage of the excluded middle third construction, we more properly use open intervals.  Suppose we cover the Cantor set  with open sets extending the intervals remaining after the middle-third removal process by an amount 1/100 on each side.  That is, if [aij,bij] is the jth interval in the ith stage of the excluded middle third process, use (aij -1/100, bij+1/100) as an open interval in the cover of the Cantor set.  Will this result in the Lebesgue measure? Explain.  
	b) Extend the intervals at the ith stage by 1/(100 2i) on each side.  Wil this result in the Lebesgue measure?
	c) Extend the intervals at the ith stage by 1/(100 5i) on each side.  What happens?  
;[s]
13:0,0;385,1;387,2;389,3;391,4;474,5;476,6;486,7;488,8;655,9;656,10;767,11;768,12;803,-1;
13:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
2. Find the Lebesgue measure of the set {0, 1/2, 1/3, 1/4, 1/5, ...}
:[font = text; inactive; preserveAspect; ]
3. Find the capacity dimension of the set {0, 1/2, 1/3, 1/4, 1/5,...}
:[font = text; inactive; preserveAspect; ]
4. Find the Hausdorff dimension of the set {0, 1/2, 1/3, 1/4, 1/5, ...}
:[font = text; inactive; preserveAspect; ]
5. Find the similarity dimension of the graph of the Cantor function. 
:[font = text; inactive; preserveAspect; ]
6. Find the similarity  dimension of a generalized Cantor set determined by the ratios r1, and r2.
;[s]
4:0,0;88,1;89,2;96,3;101,-1;
4:1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,64,12,0,0,0;
:[font = text; inactive; preserveAspect; endGroup; ]
7.  Find the dimension of the Sierpinski gasket.
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Try For Yourself
:[font = text; inactive; preserveAspect; ]
1. Show that for any x in the open interval (0,1), there are points a, b in the classical Cantor set C such that |a-b| = x.  Thus, in some sense, the Cantor set may be thin, but it is somewhat evenly distributed.
:[font = text; inactive; preserveAspect; ]
2.  Construct a Cantor-like set which has positive Lebesgue measure
:[font = text; inactive; preserveAspect; endGroup; ]
3.  Under the hypotheses of the similarity dimension theorem, show that Hds(F)  |F|s.  (This is the easy half of the proof of the theorem.  The reverse inequality is much more technical and difficult.) 
;[s]
8:0,0;73,1;74,2;75,3;79,4;80,5;84,6;85,7;206,-1;
8:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,64,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,32,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
Have Fun With Mathematica
;[s]
2:0,0;14,1;25,-1;
2:1,16,12,Times,1,18,0,0,0;1,17,13,Times,3,18,0,0,0;
:[font = text; inactive; preserveAspect; endGroup; ]
Prepare a graph or diagram of the approximate box counting dimension of the Cantor set as a function of two parameters:  the stage n of approximation of the Cantor set by the excluded-middle-third process, and the box size d.  Display how the approximations approach the dimension of the Cantor set.
;[s]
3:0,0;223,1;224,2;301,-1;
3:1,11,8,Times,0,12,0,0,0;1,0,0,Symbol,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = section; inactive; Cclosed; preserveAspect; startGroup; ]
References
:[font = text; inactive; preserveAspect; ]
 Standard textbooks on Lebesgue measure are 
:[font = input; preserveAspect; ]
Principles of  Mathematical  Analysis,3rd edition, Chapter 10, Walter Rudin, McGraw-Hill, New York, 1976
Real and Complex Analysis, 3rd edition, Walter Rudin, McGraw-Hill, New York, 1987
Real Analysis, 3rd edition,  H. L. Royden, Macmillan, New York, 1988.

Our brief  and simplified treament  is based on the discussion in
Fractal Geometry, K. J. Falconer, J. Wiley and Sons, New York, 1990. 
;[s]
11:0,0;37,1;105,2;130,3;187,4;202,5;213,6;216,7;324,8;340,9;392,10;394,-1;
11:1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
The box-counting dimension is also known as the fractal dimension and the capacity dimension and it is a popular measure of a set because it is relatively easy to approximate numerically.  A reference with a number of examples is 
	Fractals Everywhere, Michael Barnsley, Academic Press, New York, 1988.
;[s]
3:0,0;231,1;253,2;303,-1;
3:1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
The Hausdorff dimension is older, more classical and somewhat harder to compute, although it has more satisfying theoretical properties.   Some references to its properties and history are
	The Geometry of Fractal Sets, K. J. Falconer, Cambridge University Press,
	 Cambridge, 1986
and
	Fractal Geometry, K. J. Falconer, J. Wiley and Sons, New York, 1990.
;[s]
5:0,0;189,1;218,2;286,3;303,4;355,-1;
5:1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
:[font = text; inactive; preserveAspect; ]
An excellent treatment of the similarity dimension, from which our treatment is adapted is in 
:[font = input; preserveAspect; endGroup; endGroup; ]
	Fractal Geometry, K. J. Falconer, J. Wiley and Sons, New York, 1990.
;[s]
2:0,0;17,1;69,-1;
2:1,10,8,Times,2,12,0,0,0;1,11,8,Times,0,12,0,0,0;
^*)